## fastdds 3.1.0+ds

=== CMakeLists.txt ===
# Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

###############################################################################
# CMake build rules for Fast DDS
###############################################################################
cmake_minimum_required(VERSION 3.20)

# Set CMAKE_BUILD_TYPE to Release by default.
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to 'Release' as none was specified.")
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

###############################################################################
# Project                                                                     #
###############################################################################
project(fastdds VERSION "3.1.0" LANGUAGES C CXX)

set(PROJECT_NAME_LARGE "Fast DDS")
string(TOUPPER "${PROJECT_NAME}" PROJECT_NAME_UPPER)

message(STATUS "Version: ${PROJECT_VERSION}")

###############################################################################
# eProsima build options
###############################################################################
option(EPROSIMA_BUILD "Activate internal building" OFF)

###############################################################################
# Warning level
###############################################################################
if(MSVC OR MSVC_IDE)
    if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
        string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
    endif()

    if(EPROSIMA_EXTRA_CMAKE_CXX_FLAGS)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EPROSIMA_EXTRA_CMAKE_CXX_FLAGS}")
    endif()

    # make visual studio more gcc and clang like.
    # C4101 'identifier' : unreferenced local variable
    # C4189 'identifier' : local variable is initialized but not referenced
    # C4555  expression has no effect; expected expression with side-effect
    # C4715: 'Test': not all control paths return a value
    # C5038 data member 'member1' will be initialized after data member 'member2'
    # C4100 'identifier' : unreferenced formal parameter (matches clang -Wunused-lambda-capture)
    add_compile_options(/w34101 /w34189 /w34555 /w34715 /w35038 /w44100)

    if(EPROSIMA_BUILD)
        string(REPLACE "/DNDEBUG" "" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
    endif()
else()
    # Add some generic warnings common to all compilers
    set(CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} -Wall -Wpedantic -Wextra -Wno-unknown-pragmas -Wno-error=deprecated-declarations -Wno-switch-bool")
    # Add compiler specific options
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
    elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 15,0)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-builtins")
        endif()
        set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl")
    endif()

    if(EPROSIMA_EXTRA_CMAKE_CXX_FLAGS)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${EPROSIMA_EXTRA_CMAKE_CXX_FLAGS}")
    endif()

    if(EPROSIMA_BUILD)
        string(REPLACE "-DNDEBUG" "" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
    endif()
endif()

###############################################################################
# CCache on Windows on CI
###############################################################################
if (MSVC AND CMAKE_CXX_COMPILER_LAUNCHER STREQUAL "ccache")
    foreach(config DEBUG RELWITHDEBINFO)
        foreach(lang C CXX)
            set(flags_var "CMAKE_${lang}_FLAGS_${config}")
            string(REPLACE "/Zi" "/Z7" ${flags_var} "${${flags_var}}")
            set(${flags_var} "${${flags_var}}")
        endforeach()
    endforeach()
endif()

###############################################################################
# GCC colors if using CCache
###############################################################################
if("${CMAKE_CXX_COMPILER_LAUNCHER}" STREQUAL "ccache" AND
        CMAKE_COMPILER_IS_GNUCXX AND
        CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4,8)
    add_compile_options(-fdiagnostics-color=always)
endif()

###############################################################################
# Test system configuration
###############################################################################

include(${PROJECT_SOURCE_DIR}/cmake/common/check_configuration.cmake)

set(FORCE_CXX "11" CACHE STRING "C++ standard fulfillment selection")
check_stdcxx(${FORCE_CXX})

check_endianness()

###############################################################################
# Activate Sanitizers
###############################################################################
option(SANITIZER "Enable Thread or Address sanitizers" OFF)
string(TOUPPER ${SANITIZER} SANITIZER)

if (SANITIZER)
    if(${SANITIZER} STREQUAL "ADDRESS")
        message(STATUS "Enabling address sanitizer...")
        # Warning/Error messages
        if(NOT (CMAKE_BUILD_TYPE STREQUAL "Debug"))
            message(WARNING "Address sanitizer results with an optimized (non-Debug) build may be misleading")
        endif()

        if("${CMAKE_C_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang" OR "${CMAKE_CXX_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
            message(STATUS "Building with llvm Address sanitizer Tools")

            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address")

        elseif(CMAKE_COMPILER_IS_GNUCXX)
            message(STATUS "Building with Address sanitizer Tools")

            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")

        else()
            message(FATAL_ERROR "Address sanitizer requires Clang or GCC. Aborting.")
        endif()

    elseif(${SANITIZER} STREQUAL "THREAD")
        message(STATUS "Enabling thread sanitizer...")
        # Warning/Error messages
        if(NOT (CMAKE_BUILD_TYPE STREQUAL "Debug"))
            message(WARNING "Thread sanitizer results with an optimized (non-Debug) build may be misleading")
        endif()

        if("${CMAKE_C_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang" OR "${CMAKE_CXX_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
            message(STATUS "Building with llvm Thread sanitizer Tools")

            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=thread")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread")

        elseif(CMAKE_COMPILER_IS_GNUCXX)
            message(STATUS "Building with Thread sanitizer Tools")

            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=thread -fno-omit-frame-pointer")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-omit-frame-pointer")

        else()
            message(FATAL_ERROR "Thread sanitizer requires Clang or GCC. Aborting.")
        endif()

    else()
        message(WARNING "Sanitizer option not supported. Continuing without any code instrumentation... ")

    endif()
endif()

###############################################################################
# Set warnings as errors if the thread sanitizer is not being used
###############################################################################
string(FIND ${CMAKE_CXX_FLAGS} "-fsanitize=thread" SANITIZER_THREAD)
if (${SANITIZER_THREAD} EQUAL -1)
    message(STATUS "Setting warnings as errors...")
    if(MSVC OR MSVC_IDE)
        add_compile_options(/WX)
    else()
        set(CMAKE_CXX_FLAGS
            "${CMAKE_CXX_FLAGS} -Werror")
    endif()
endif()

###############################################################################
# Installation paths
###############################################################################
option(APPEND_PROJECT_NAME_TO_INCLUDEDIR
  "When ON headers are installed to a path ending with a folder called \
  ${PROJECT_NAME}. This avoids include directory search order issues when \
  overriding this package from a merged catkin, ament, or colcon workspace."
  OFF)

set(BIN_INSTALL_DIR bin/ CACHE PATH "Installation directory for binaries")
set(_include_dir "include/")
if(APPEND_PROJECT_NAME_TO_INCLUDEDIR)
  string(APPEND _include_dir "${PROJECT_NAME}/")
endif()
set(INCLUDE_INSTALL_DIR "${_include_dir}" CACHE PATH "Installation directory for C++ headers")
unset(_include_dir)
set(LIB_INSTALL_DIR lib${LIB_SUFFIX}/ CACHE PATH "Installation directory for libraries")
set(DATA_INSTALL_DIR share/ CACHE PATH "Installation directory for data")
if(WIN32)
    set(DOC_DIR "doc")
else()
    set(DOC_DIR "${DATA_INSTALL_DIR}/doc")
endif()
set(DOC_INSTALL_DIR ${DOC_DIR} CACHE PATH "Installation directory for documentation")
set(LICENSE_INSTALL_DIR ${DATA_INSTALL_DIR}/${PROJECT_NAME} CACHE PATH "Installation directory for licenses")

###############################################################################
# Internal debug messages
###############################################################################

if(EPROSIMA_BUILD)
    set(INTERNAL_DEBUG ON)
endif()

###############################################################################
# Load CMake modules
###############################################################################
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake/modules)

###############################################################################
# Default shared libraries
###############################################################################
# Global flag to cause add_library() to create shared libraries if on.
# If set to true, this will cause all libraries to be built shared
# unless the library was explicitly added as a static library.
option(BUILD_SHARED_LIBS "Create shared libraries by default" ON)

###############################################################################
# Load external projects.
###############################################################################
include(${PROJECT_SOURCE_DIR}/cmake/common/eprosima_libraries.cmake)

# if we are building Fast DDS as a static library we must load Fast-CDR as one
if(NOT BUILD_SHARED_LIBS)
    set(FASTDDS_STATIC ON)
endif()

eprosima_find_package(fastcdr 2 REQUIRED)
eprosima_find_thirdparty(Asio asio VERSION 1.10.8)
eprosima_find_thirdparty(TinyXML2 tinyxml2)

find_package(foonathan_memory REQUIRED)
message(STATUS "Found foonathan_memory: ${foonathan_memory_DIR}")
find_package(ThirdpartyBoost REQUIRED)

if(ANDROID)
    if((ANDROID_PLATFORM LESS_EQUAL 23) OR (ANDROID_NATIVE_API_LEVEL LESS_EQUAL 23))
        eprosima_find_thirdparty(android-ifaddrs android-ifaddrs)
    endif()
endif()

include_directories(thirdparty/nlohmann-json)
include_directories(thirdparty/filewatch)

###############################################################################
# Options
###############################################################################

=== src/cpp/CMakeLists.txt ===
# Copyright 2019 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

include(CheckCXXSourceCompiles)

add_subdirectory(fastdds/log)
add_subdirectory(fastdds/xtypes)

# Set source files
if(WIN32)

file(GLOB_RECURSE ALL_HEADERS
    ${PROJECT_SOURCE_DIR}/include/**/*.h
    ${PROJECT_SOURCE_DIR}/include/**/*.hpp
    ${PROJECT_SOURCE_DIR}/src/cpp/**/*.h
    ${PROJECT_SOURCE_DIR}/src/cpp/**/*.hpp
    )

add_definitions(-DNOMINMAX)

endif(WIN32)

file(GLOB DDSSQLFILTER_SOURCES fastdds/topic/DDSSQLFilter/*.cpp)


set(${PROJECT_NAME}_source_files
    ${ALL_HEADERS}

    ${DDSSQLFILTER_SOURCES}

    fastdds/builtin/type_lookup_service/detail/rpc_typesPubSubTypes.cxx
    fastdds/builtin/type_lookup_service/detail/TypeLookupTypesPubSubTypes.cxx
    fastdds/builtin/type_lookup_service/TypeLookupManager.cpp
    fastdds/builtin/type_lookup_service/TypeLookupRequestListener.cpp
    fastdds/builtin/type_lookup_service/TypeLookupReplyListener.cpp
    fastdds/core/condition/Condition.cpp
    fastdds/core/condition/ConditionNotifier.cpp
    fastdds/core/condition/GuardCondition.cpp
    fastdds/core/condition/StatusCondition.cpp
    fastdds/core/condition/StatusConditionImpl.cpp
    fastdds/core/condition/WaitSet.cpp
    fastdds/core/condition/WaitSetImpl.cpp
    fastdds/core/Entity.cpp
    fastdds/core/policy/ParameterList.cpp
    fastdds/core/policy/QosPolicyUtils.cpp
    fastdds/core/Time_t.cpp
    fastdds/domain/DomainParticipant.cpp
    fastdds/domain/DomainParticipantFactory.cpp
    fastdds/domain/DomainParticipantImpl.cpp
    fastdds/domain/qos/DomainParticipantFactoryQos.cpp
    fastdds/domain/qos/DomainParticipantQos.cpp
    fastdds/log/FileConsumer.cpp
    fastdds/log/Log.cpp
    fastdds/log/OStreamConsumer.cpp
    fastdds/log/StdoutConsumer.cpp
    fastdds/log/StdoutErrConsumer.cpp
    fastdds/publisher/DataWriter.cpp
    fastdds/publisher/DataWriterHistory.cpp
    fastdds/publisher/DataWriterImpl.cpp
    fastdds/publisher/Publisher.cpp
    fastdds/publisher/PublisherImpl.cpp
    fastdds/publisher/qos/DataWriterQos.cpp
    fastdds/publisher/qos/PublisherQos.cpp
    fastdds/publisher/qos/WriterQos.cpp
    fastdds/subscriber/DataReader.cpp
    fastdds/subscriber/DataReaderImpl.cpp
    fastdds/subscriber/history/DataReaderHistory.cpp
    fastdds/subscriber/qos/DataReaderQos.cpp
    fastdds/subscriber/qos/ReaderQos.cpp
    fastdds/subscriber/qos/SubscriberQos.cpp
    fastdds/subscriber/ReadCondition.cpp
    fastdds/subscriber/Subscriber.cpp
    fastdds/subscriber/SubscriberImpl.cpp
    fastdds/topic/ContentFilteredTopic.cpp
    fastdds/topic/ContentFilteredTopicImpl.cpp
    fastdds/topic/qos/TopicQos.cpp
    fastdds/topic/Topic.cpp
    fastdds/topic/TopicImpl.cpp
    fastdds/topic/TopicProxyFactory.cpp
    fastdds/topic/TypeSupport.cpp
    fastdds/utils/QosConverters.cpp
    fastdds/utils/TypePropagation.cpp
    fastdds/xtypes/dynamic_types/AnnotationDescriptorImpl.cpp
    fastdds/xtypes/dynamic_types/DynamicDataFactory.cpp
    fastdds/xtypes/dynamic_types/DynamicDataImpl.cpp
    fastdds/xtypes/dynamic_types/DynamicDataFactoryImpl.cpp
    fastdds/xtypes/dynamic_types/DynamicPubSubType.cpp
    fastdds/xtypes/dynamic_types/DynamicTypeImpl.cpp
    fastdds/xtypes/dynamic_types/DynamicTypeBuilderFactory.cpp
    fastdds/xtypes/dynamic_types/DynamicTypeBuilderImpl.cpp
    fastdds/xtypes/dynamic_types/DynamicTypeBuilderFactoryImpl.cpp
    fastdds/xtypes/dynamic_types/DynamicTypeMemberImpl.cpp
    fastdds/xtypes/dynamic_types/MemberDescriptorImpl.cpp
    fastdds/xtypes/dynamic_types/TypeDescriptorImpl.cpp
    fastdds/xtypes/dynamic_types/VerbatimTextDescriptorImpl.cpp
    fastdds/xtypes/exception/Exception.cpp
    fastdds/xtypes/serializers/idl/dynamic_type_idl.cpp
    fastdds/xtypes/serializers/json/dynamic_data_json.cpp
    fastdds/xtypes/type_representation/dds_xtypes_typeobjectPubSubTypes.cxx
    fastdds/xtypes/type_representation/TypeObjectRegistry.cpp
    fastdds/xtypes/type_representation/TypeObjectUtils.cpp
    fastdds/xtypes/utils.cpp
    rtps/attributes/EndpointSecurityAttributes.cpp
    rtps/attributes/PropertyPolicy.cpp
    rtps/attributes/RTPSParticipantAttributes.cpp
    rtps/attributes/ServerAttributes.cpp
    rtps/attributes/ThreadSettings.cpp
    rtps/builtin/BuiltinProtocols.cpp
    rtps/builtin/data/ParticipantProxyData.cpp
    rtps/builtin/data/ProxyDataConverters.cpp
    rtps/builtin/data/ReaderProxyData.cpp
    rtps/builtin/data/WriterProxyData.cpp
    rtps/builtin/discovery/database/backup/SharedBackupFunctions.cpp
    rtps/builtin/discovery/database/DiscoveryDataBase.cpp
    rtps/builtin/discovery/database/DiscoveryParticipantInfo.cpp
    rtps/builtin/discovery/database/DiscoveryParticipantsAckStatus.cpp
    rtps/builtin/discovery/database/DiscoverySharedInfo.cpp
    rtps/builtin/discovery/endpoint/EDP.cpp
    rtps/builtin/discovery/endpoint/EDPClient.cpp
    rtps/builtin/discovery/endpoint/EDPServer.cpp
    rtps/builtin/discovery/endpoint/EDPServerListeners.cpp
    rtps/builtin/discovery/endpoint/EDPSimple.cpp
    rtps/builtin/discovery/endpoint/EDPSimpleListeners.cpp
    rtps/builtin/discovery/endpoint/EDPStatic.cpp
    rtps/builtin/discovery/participant/DirectMessageSender.cpp
    rtps/builtin/discovery/participant/PDP.cpp
    rtps/builtin/discovery/participant/PDPClient.cpp
    rtps/builtin/discovery/participant/PDPClientListener.cpp
    rtps/builtin/discovery/participant/PDPListener.cpp
    rtps/builtin/discovery/participant/PDPServer.cpp
    rtps/builtin/discovery/participant/PDPServerListener.cpp
    rtps/builtin/discovery/participant/PDPSimple.cpp
    rtps/builtin/discovery/participant/timedevent/DSClientEvent.cpp
    rtps/builtin/discovery/participant/timedevent/DServerEvent.cpp
    rtps/builtin/liveliness/WLP.cpp
    rtps/builtin/liveliness/WLPListener.cpp
    rtps/common/GuidPrefix_t.cpp
    rtps/common/SerializedPayload.cpp
    rtps/common/LocatorWithMask.cpp
    rtps/common/Time_t.cpp
    rtps/common/Token.cpp
    rtps/DataSharing/DataSharingListener.cpp
    rtps/DataSharing/DataSharingNotification.cpp
    rtps/DataSharing/DataSharingPayloadPool.cpp
    rtps/exceptions/Exception.cpp
    rtps/flowcontrol/FlowControllerConsts.cpp
    rtps/flowcontrol/FlowControllerFactory.cpp
    rtps/history/CacheChangePool.cpp
    rtps/history/History.cpp
    rtps/history/ReaderHistory.cpp
    rtps/history/TopicPayloadPool.cpp
    rtps/history/TopicPayloadPoolRegistry.cpp
    rtps/history/WriterHistory.cpp
    rtps/messages/CDRMessage.cpp
    rtps/messages/MessageReceiver.cpp
    rtps/messages/RTPSGapBuilder.cpp
    rtps/messages/RTPSMessageCreator.cpp
    rtps/messages/RTPSMessageGroup.cpp
    rtps/messages/SendBuffersManager.cpp
    rtps/messages/submessages/AckNackMsg.hpp
    rtps/messages/submessages/DataMsg.hpp
    rtps/messages/submessages/GapMsg.hpp
    rtps/messages/submessages/HeartbeatMsg.hpp
    rtps/network/NetworkBuffer.cpp
    rtps/network/NetworkFactory.cpp
    rtps/network/ReceiverResource.cpp
    rtps/network/utils/external_locators.cpp
    rtps/network/utils/netmask_filter.cpp
    rtps/network/utils/network.cpp
    rtps/participant/RTPSParticipant.cpp
    rtps/participant/RTPSParticipantImpl.cpp
    rtps/persistence/PersistenceFactory.cpp
    rtps/reader/BaseReader.cpp
    rtps/reader/reader_utils.cpp
    rtps/reader/RTPSReader.cpp
    rtps/reader/StatefulPersistentReader.cpp
    rtps/reader/StatefulReader.cpp
    rtps/reader/StatelessPersistentReader.cpp
    rtps/reader/StatelessReader.cpp
    rtps/reader/WriterProxy.cpp
    rtps/resources/ResourceEvent.cpp
    rtps/resources/TimedEvent.cpp
    rtps/resources/TimedEventImpl.cpp
    rtps/RTPSDomain.cpp
    rtps/transport/ChainingTransport.cpp
    rtps/transport/ChannelResource.cpp
    rtps/transport/network/NetmaskFilterKind.cpp
    rtps/transport/network/NetworkInterface.cpp
    rtps/transport/network/NetworkInterfaceWithFilter.cpp
    rtps/transport/PortBasedTransportDescriptor.cpp
    rtps/transport/shared_mem/SharedMemTransportDescriptor.cpp
    rtps/transport/tcp/RTCPMessageManager.cpp
    rtps/transport/tcp/TCPControlMessage.cpp
    rtps/transport/TCPAcceptor.cpp
    rtps/transport/TCPAcceptorBasic.cpp
    rtps/transport/TCPChannelResource.cpp
    rtps/transport/TCPChannelResourceBasic.cpp
    rtps/transport/TCPTransportInterface.cpp
    rtps/transport/TCPv4Transport.cpp
    rtps/transport/TCPv6Transport.cpp
    rtps/transport/test_UDPv4Transport.cpp
    rtps/transport/TransportInterface.cpp
    rtps/transport/UDPChannelResource.cpp
    rtps/transport/UDPTransportInterface.cpp
    rtps/transport/UDPv4Transport.cpp
    rtps/transport/UDPv6Transport.cpp
    rtps/writer/BaseWriter.cpp
    rtps/writer/LivelinessManager.cpp
    rtps/writer/LocatorSelectorSender.cpp
    rtps/writer/PersistentWriter.cpp
    rtps/writer/ReaderLocator.cpp
    rtps/writer/ReaderProxy.cpp
    rtps/writer/RTPSWriter.cpp
    rtps/writer/StatefulPersistentWriter.cpp
    rtps/writer/StatefulWriter.cpp
    rtps/writer/StatelessPersistentWriter.cpp
    rtps/writer/StatelessWriter.cpp
    statistics/fastdds/domain/DomainParticipant.cpp
    statistics/fastdds/publisher/qos/DataWriterQos.cpp
    statistics/fastdds/subscriber/qos/DataReaderQos.cpp
    utils/IPFinder.cpp
    utils/IPLocator.cpp
    utils/md5.cpp
    utils/StringMatching.cpp
    utils/SystemInfo.cpp
    utils/TimedConditionVariable.cpp
    utils/UnitsParser.cpp
    xmlparser/attributes/TopicAttributes.cpp
    xmlparser/XMLDynamicParser.cpp
    xmlparser/XMLElementParser.cpp
    xmlparser/XMLEndpointParser.cpp
    xmlparser/XMLParser.cpp
    xmlparser/XMLParserCommon.cpp
    xmlparser/XMLProfileManager.cpp
    )

# Statistics support
if (FASTDDS_STATISTICS)

    set(statistics_sources
        statistics/fastdds/domain/DomainParticipantImpl.cpp
        statistics/fastdds/domain/DomainParticipantStatisticsListener.cpp
        statistics/rtps/monitor-service/MonitorService.cpp
        statistics/rtps/monitor-service/MonitorServiceListener.cpp
        statistics/rtps/reader/StatisticsReaderImpl.cpp
        statistics/rtps/StatisticsBase.cpp
        statistics/rtps/writer/StatisticsWriterImpl.cpp
        statistics/types/monitorservice_typesPubSubTypes.cxx
        statistics/types/monitorservice_typesTypeObjectSupport.cxx
        statistics/types/typesPubSubTypes.cxx
        statistics/types/typesTypeObjectSupport.cxx
        )

    list(APPEND ${PROJECT_NAME}_source_files
        ${statistics_sources}
        )

endif()

# SHM Transport
if(IS_THIRDPARTY_BOOST_OK)
    list(APPEND ${PROJECT_NAME}_source_files
        rtps/transport/shared_mem/test_SharedMemTransport.cpp
        rtps/transport/shared_mem/SharedMemTransport.cpp
        )
endif()

# TLS Support
if(TLS_FOUND)
    list(APPEND ${PROJECT_NAME}_source_files
        rtps/transport/TCPChannelResourceSecure.cpp
        rtps/transport/TCPAcceptorSecure.cpp
        )
endif()

# Security sources
set(${PROJECT_NAME}_security_source_files
    rtps/security/exceptions/SecurityException.cpp
    rtps/security/common/SharedSecretHandle.cpp
    rtps/security/logging/Logging.cpp
    rtps/security/logging/LoggingLevel.cpp
    rtps/security/SecurityManager.cpp
    rtps/security/SecurityPluginFactory.cpp
    rtps/builtin/discovery/participant/DS/PDPSecurityInitiatorListener.cpp
    security/authentication/PKIDH.cpp
    security/accesscontrol/Permissions.cpp
    security/accesscontrol/DistinguishedName.cpp
    security/cryptography/AESGCMGMAC.cpp
    security/cryptography/AESGCMGMAC_KeyExchange.cpp

=== tools/fds/CMakeLists.txt ===
# Copyright 2020 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.20)

project(fast-discovery-server VERSION 1.0.1 LANGUAGES CXX)

###############################################################################
# Load external dependencies
###############################################################################

if(NOT fastdds_FOUND)
    find_package(fastdds 3 REQUIRED)
endif()

###############################################################################
# Compilation
###############################################################################

if (MSVC)

    # For isolated builds provide some IDE aids
    if (CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)

        # add fast headers to enable class view on visual studio IDE
        get_target_property(FAST_INCLUDE_DIR fastdds INTERFACE_INCLUDE_DIRECTORIES)
        list(GET FAST_INCLUDE_DIR 0 FAST_INCLUDE_DIR)

        file(GLOB_RECURSE ALL_FAST_HEADERS
            "${FAST_INCLUDE_DIR}/**/*.h"
            "${FAST_INCLUDE_DIR}/**/*.hpp"
            "${FAST_INCLUDE_DIR}/**/*.hxx"
            )

        source_group("Fast DDS Headers" FILES ${ALL_FAST_HEADERS})

    endif()

    # add project headers to enable class view on visual studio IDE
    set(FAST_SERVER_HEADERS server.h)

endif(MSVC)

add_executable(${PROJECT_NAME}
    server.cpp
    ${FAST_SERVER_HEADERS}
    ${ALL_FAST_HEADERS})

# we pass the version as a preprocessor definition
target_compile_definitions(${PROJECT_NAME}
    PRIVATE FAST_SERVER_VERSION=\"${PROJECT_VERSION}\"
    PRIVATE FAST_SERVER_BINARY=\"$<TARGET_FILE_NAME:${PROJECT_NAME}>\" )

target_link_libraries(${PROJECT_NAME} fastdds fastcdr fastdds::optionparser)

# Properties that change bin names depending on current config.
# This is convenient because on installation all bins share folder
set_target_properties(${PROJECT_NAME} PROPERTIES RELEASE_POSTFIX -${PROJECT_VERSION})
set_target_properties(${PROJECT_NAME} PROPERTIES MINSIZEREL_POSTFIX m-${PROJECT_VERSION})
set_target_properties(${PROJECT_NAME} PROPERTIES RELWITHDEBINFO_POSTFIX rd-${PROJECT_VERSION})
set_target_properties(${PROJECT_NAME} PROPERTIES DEBUG_POSTFIX d-${PROJECT_VERSION})

###############################################################################
# Installation
###############################################################################

# If not isolated integrate
if(CMAKE_PROJECT_NAME STREQUAL "fastdds" )
    set(BIN_INSTALL_DIR tools/fds/${BIN_INSTALL_DIR} CACHE PATH "Installation directory for binaries within Fast DDS")
else()
    set(BIN_INSTALL_DIR bin/ CACHE PATH "Installation directory for binaries")
endif()

install(TARGETS ${PROJECT_NAME}
        EXPORT ${PROJECT_NAME}-targets
        RUNTIME DESTINATION ${BIN_INSTALL_DIR}${MSVCARCH_DIR_EXTENSION}
        COMPONENT discovery
        )

    if(INSTALLER_PLATFORM)
        set(INSTALL_DESTINATION_PATH ${DATA_INSTALL_DIR}/${CMAKE_PROJECT_NAME}-${INSTALLER_PLATFORM}/cmake)
    else()
        set(INSTALL_DESTINATION_PATH ${DATA_INSTALL_DIR}/${CMAKE_PROJECT_NAME}/cmake)
    endif()

# export library
install(EXPORT ${PROJECT_NAME}-targets
        DESTINATION ${INSTALL_DESTINATION_PATH}
        NAMESPACE fastdds::
        COMPONENT cmake
        )

# symlink creation requires:
#   - install( CODE using generator expressions (legacy code is provided for all cmake versions)
#   - on windows privileges to create symlinks (a .bat file is provided on unprivileged installations)
if( WIN32 )
    # Use powershell to generate the link
    install(
      CODE "execute_process( COMMAND PowerShell -Command \"if( test-path ${PROJECT_NAME}.exe -PathType Leaf ) { rm ${PROJECT_NAME}.exe } ; New-Item -ItemType SymbolicLink -Target $<TARGET_FILE_NAME:${PROJECT_NAME}> -Path ${PROJECT_NAME}.exe \" ERROR_QUIET RESULTS_VARIABLE SYMLINK_FAILED WORKING_DIRECTORY \"${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}\") \n if( SYMLINK_FAILED ) \n message(STATUS \"Windows requires admin installation rights to create symlinks. A bat script will be provided instead.\") \n set(FAST_SERVER_BINARY_NAME $<TARGET_FILE_NAME:${PROJECT_NAME}>) \n configure_file(${CMAKE_CURRENT_LIST_DIR}/fast-discovery-server.bat.in ${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}${MSVCARCH_DIR_EXTENSION}/${PROJECT_NAME}.bat @ONLY) \n endif()"
      COMPONENT discovery)
else()
    # Use ln to create the symbolic link. We remove the version from the file name but keep the debug suffix
    install(
        CODE "execute_process(COMMAND bash -c \"if [[ -h ${PROJECT_NAME} ]]; then rm ${PROJECT_NAME}; fi;  ln -s $<TARGET_FILE_NAME:${PROJECT_NAME}> ${PROJECT_NAME}\" WORKING_DIRECTORY \"\$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/${BIN_INSTALL_DIR}${MSVCARCH_DIR_EXTENSION}\")"
        COMPONENT discovery)
endif()

=== test/system/tools/fastdds/CMakeLists.txt ===
# Copyright 2020 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

###########################################################################
# Create tests                                                            #
###########################################################################

find_package(Python3 COMPONENTS Interpreter REQUIRED)

if(Python3_Interpreter_FOUND)

    # Set environment for tests
    set(TEST_ENVIRONMENT
        "PYTHON_VERSION=${Python3_VERSION_MAJOR}.${Python3_VERSION_MINOR}")

    set(TESTS
        test_fastdds_installed
        test_fastdds_discovery
        test_ros_discovery
        test_fastdds_shm
        test_fastdds_xml_validate
    )

    foreach(TEST IN LISTS TESTS)
        add_test(
                NAME system.tools.fastdds.${TEST}
                COMMAND ${Python3_EXECUTABLE}
                ${CMAKE_CURRENT_SOURCE_DIR}/tests.py
                ${CMAKE_INSTALL_PREFIX}
                ${TEST}
            )

        # Set test properties
        set_property(
            TEST system.tools.fastdds.${TEST}
            PROPERTY LABELS "NoMemoryCheck"
        )

        # Set environment
        set_property(
            TEST system.tools.fastdds.${TEST}
            PROPERTY ENVIRONMENT ${TEST_ENVIRONMENT}
        )

    endforeach()

    ###############################################################################
    # XML GENERAL validation
    ###############################################################################
    message(STATUS "Configuring CLI xml validation...")

    # Configure command based on the OS running
    if (MSVC)
        set(env_fast_command "fastdds.bat") # WINDOWS
    else()
        set(env_fast_command "fastdds")     # POSIX
    endif()

    # Copy the examples validation files over to the build directory
    file(GLOB_RECURSE XML_EXAMPLE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/../../../../examples/*_profile.xml)
    # for each xml file detected
    foreach(XML_EXAMPLE_FILE_COMPLETE_PATH ${XML_EXAMPLE_FILES})
        # obtain the file name
        get_filename_component(XML_EXAMPLE_FILE ${XML_EXAMPLE_FILE_COMPLETE_PATH} NAME_WE)
        # copy the file from src to build folders
        configure_file(
            ${XML_EXAMPLE_FILE_COMPLETE_PATH}                                          # from full src path
            ${CMAKE_CURRENT_BINARY_DIR}/xmldocuments/examples/${XML_EXAMPLE_FILE}.xml  # to relative build path
            COPYONLY)
    endforeach()

    # Copy the blackbox tests validation files over to the build directory
    file(GLOB_RECURSE XML_BLACKBOX_FILES ${CMAKE_CURRENT_SOURCE_DIR}/../../../blackbox/*_profile.xml)
    # for each xml file detected
    foreach(XML_BLACKBOX_FILE_COMPLETE_PATH ${XML_BLACKBOX_FILES})
        # obtain the file name
        get_filename_component(XML_BLACKBOX_FILE ${XML_BLACKBOX_FILE_COMPLETE_PATH} NAME_WE)
        # copy the file from src to build folders
        configure_file(
            ${XML_BLACKBOX_FILE_COMPLETE_PATH}                                               # from full src path
            ${CMAKE_CURRENT_BINARY_DIR}/xmldocuments/test/blackbox/${XML_BLACKBOX_FILE}.xml  # to relative build path
            COPYONLY)
    endforeach()

    # Copy the unit tests validation files over to the build directory
    file(GLOB_RECURSE XML_UNITTEST_FILES ${CMAKE_CURRENT_SOURCE_DIR}/../../../unittest/*_profile.xml)
    # for each xml file detected
    foreach(XML_UNITTEST_FILE_COMPLETE_PATH ${XML_UNITTEST_FILES})
        # obtain the file name
        get_filename_component(XML_UNITTEST_FILE ${XML_UNITTEST_FILE_COMPLETE_PATH} NAME_WE)
        # copy the file from src to build folders
        configure_file(
            ${XML_UNITTEST_FILE_COMPLETE_PATH}                                              # from full src path
            ${CMAKE_CURRENT_BINARY_DIR}/xmldocuments/test/unittest/${XML_UNITTEST_FILE}.xml # to relative build path
            COPYONLY)
    endforeach()

    # Copy the system tests validation files over to the build directory
    file(GLOB_RECURSE XML_SYSTEM_FILES ${CMAKE_CURRENT_SOURCE_DIR}/../*_profile.xml)
    # for each xml file detected
    foreach(XML_SYSTEM_FILE_COMPLETE_PATH ${XML_SYSTEM_FILES})
        # obtain the file name
        get_filename_component(XML_SYSTEM_FILE ${XML_SYSTEM_FILE_COMPLETE_PATH} NAME_WE)
        # copy the file from src to build folders
        configure_file(
            ${XML_SYSTEM_FILE_COMPLETE_PATH}                                            # from full src path
            ${CMAKE_CURRENT_BINARY_DIR}/xmldocuments/test/system/${XML_SYSTEM_FILE}.xml # to relative build path
            COPYONLY)
    endforeach()

    # Copy the comunication tests validation files over to the build directory
    file(GLOB_RECURSE XML_COMMUNICATION_FILES ${CMAKE_CURRENT_SOURCE_DIR}/../../../communication/*_profile.xml)
    # for each xml file detected
    foreach(XML_COMMUNICATION_FILE_COMPLETE_PATH ${XML_COMMUNICATION_FILES})
        # obtain the file name
        get_filename_component(XML_COMMUNICATION_FILE ${XML_COMMUNICATION_FILE_COMPLETE_PATH} NAME_WE)
        # copy the file from src to build folders
        configure_file(
            ${XML_COMMUNICATION_FILE_COMPLETE_PATH}                                                   # from full src path
            ${CMAKE_CURRENT_BINARY_DIR}/xmldocuments/test/communication/${XML_COMMUNICATION_FILE}.xml # to relative build path
            COPYONLY)
    endforeach()

    # Copy the dds tests validation files over to the build directory
    file(GLOB_RECURSE XML_DDS_TEST_FILES ${CMAKE_CURRENT_SOURCE_DIR}/../../../dds/*_profile.xml)
    # for each xml file detected
    foreach(XML_DDS_TEST_FILE_COMPLETE_PATH ${XML_DDS_TEST_FILES})
        # obtain the file name
        get_filename_component(XML_DDS_TEST_FILE ${XML_DDS_TEST_FILE_COMPLETE_PATH} NAME_WE)
        # copy the file from src to build folders
        configure_file(
            ${XML_DDS_TEST_FILE_COMPLETE_PATH}                                         # from full src path
            ${CMAKE_CURRENT_BINARY_DIR}/xmldocuments/test/dds/${XML_DDS_TEST_FILE}.xml # to relative build path
            COPYONLY)
    endforeach()

    if(PERFORMANCE_TESTS)
        # Copy the performance tests validation files over to the build directory
        file(GLOB_RECURSE XML_PERFORMANCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/../../../performance/*_profile.xml)
        # for each xml file detected
        foreach(XML_PERFORMANCE_FILE_COMPLETE_PATH ${XML_PERFORMANCE_FILES})
            # obtain the file name
            get_filename_component(XML_PERFORMANCE_FILE ${XML_PERFORMANCE_FILE_COMPLETE_PATH} NAME_WE)
            # copy the file from src to build folders
            configure_file(
                ${XML_PERFORMANCE_FILE_COMPLETE_PATH}                                                 # from full src path
                ${CMAKE_CURRENT_BINARY_DIR}/xmldocuments/test/performance/${XML_PERFORMANCE_FILE}.xml # to relative build path
                COPYONLY)
        endforeach()
    endif()

    if(PROFILING_TESTS)
        # Copy the profiling tests validation files over to the build directory
        file(GLOB_RECURSE XML_PROFILING_FILES ${CMAKE_CURRENT_SOURCE_DIR}/../../../profiling/*_profile.xml)
        # for each xml file detected
        foreach(XML_PROFILING_FILE_COMPLETE_PATH ${XML_PROFILING_FILES})
            # obtain the file name
            get_filename_component(XML_PROFILING_FILE ${XML_PROFILING_FILE_COMPLETE_PATH} NAME_WE)
            # copy the file from src to build folders
            configure_file(
                ${XML_PROFILING_FILE_COMPLETE_PATH}                                               # from full src path
                ${CMAKE_CURRENT_BINARY_DIR}/xmldocuments/test/profiling/${XML_PROFILING_FILE}.xml # to relative build path
                COPYONLY)
        endforeach()
    endif()

    # Define test
    add_test(NAME xml.validate COMMAND ${env_fast_command} xml validate xmldocuments)

    set_property(
        TEST xml.validate
        PROPERTY ENVIRONMENT ${TEST_ENVIRONMENT}
    )

    ###############################################################################
    # XML Static discovery validation
    ###############################################################################

    # Copy the examples validation files over to the build directory
    file(GLOB_RECURSE STATIC_DISC_XML_EXAMPLE ${CMAKE_CURRENT_SOURCE_DIR}/../../../../examples/*_static_disc.xml)

    # for each xml file detected in examples folder
    foreach(STATIC_DISC_XML_EXAMPLE_COMPLETE_PATH ${STATIC_DISC_XML_EXAMPLE})
        # obtain the file name
        get_filename_component(STATIC_DISC_XML_EXAMPLE ${STATIC_DISC_XML_EXAMPLE_COMPLETE_PATH} NAME_WE)
        # copy the file from src to build folders
        configure_file(
            ${STATIC_DISC_XML_EXAMPLE_COMPLETE_PATH}                                                 # from full src path
            ${CMAKE_CURRENT_BINARY_DIR}/xml_static_disc_docs/examples/${STATIC_DISC_XML_EXAMPLE}.xml # to relative build path
            COPYONLY)
    endforeach()

    # Copy the test validation files over to the build directory
    file(GLOB_RECURSE STATIC_DISC_XML_TEST ${CMAKE_CURRENT_SOURCE_DIR}/../*_static_disc.xml)

    # for each xml file detected in test folder
    foreach(STATIC_DISC_XML_TEST_COMPLETE_PATH ${STATIC_DISC_XML_TEST})
        # obtain the file name
        get_filename_component(STATIC_DISC_XML_TEST ${STATIC_DISC_XML_TEST_COMPLETE_PATH} NAME_WE)
        # copy the file from src to build folders
        configure_file(
            ${STATIC_DISC_XML_TEST_COMPLETE_PATH}                                             # from full src path
            ${CMAKE_CURRENT_BINARY_DIR}/xml_static_disc_docs/test/system/${STATIC_DISC_XML_TEST}.xml # to relative build path
            COPYONLY)
    endforeach()

    # Copy the sampled test files over to the build directory
    file(GLOB_RECURSE STATIC_DISC_XML_SAMPLED_TEST ${CMAKE_CURRENT_SOURCE_DIR}/../../../blackbox/*_static_disc.xml.in)

    # set the expected CMake variables for the samples
    set(TOPIC_RANDOM_NUMBER "123")
    set(W_UNICAST_PORT_RANDOM_NUMBER "456")
    set(R_UNICAST_PORT_RANDOM_NUMBER "654")
    set(MULTICAST_PORT_RANDOM_NUMBER "789")

    # for each xml file detected in examples folder
    foreach(STATIC_DISC_XML_SAMPLED_TEST_COMPLETE_PATH ${STATIC_DISC_XML_SAMPLED_TEST})
        # obtain the file name
        get_filename_component(STATIC_DISC_XML_SAMPLED_TEST ${STATIC_DISC_XML_SAMPLED_TEST_COMPLETE_PATH} NAME_WE)
        # copy the file from src to build folders
        configure_file(
            ${STATIC_DISC_XML_SAMPLED_TEST_COMPLETE_PATH}                                                 # from full src path
            ${CMAKE_CURRENT_BINARY_DIR}/xml_static_disc_docs/test/blackbox/${STATIC_DISC_XML_SAMPLED_TEST}.xml # to relative build path
            )
    endforeach()

    # Define test
    add_test(NAME xml.static_disc_validate COMMAND ${env_fast_command} xml validate xml_static_disc_docs -x ${CMAKE_SOURCE_DIR}/resources/xsd/fastdds_static_discovery.xsd)

    set_property(
            TEST xml.static_disc_validate
            PROPERTY ENVIRONMENT ${TEST_ENVIRONMENT}
    )

endif()

=== debian/changelog ===
fastdds (3.1.0+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Fri, 22 Nov 2024 15:37:40 +0100

fastdds (3.1.0+ds-1) experimental; urgency=medium

  * Update d/watch to latest GitHub recipe
  * New upstream version 3.1.0+ds
  * Refresh patches (no functional changes)
  * Wrap and sort Debian package files
  * Bump SONAME to 3.1

 -- Timo Röhling <roehling@debian.org>  Mon, 14 Oct 2024 20:36:14 +0200

=== debian/control ===
Source: fastdds
Section: libs
Priority: optional
Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders:
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 doxygen <!nodoc>,
 dpkg-dev (>= 1.22.5),
 graphviz <!nodoc>,
 libasio-dev,
 libboost-dev,
 libfastcdr-dev (>= 2.2),
 libfoonathan-memory-dev,
 libgmock-dev <!nocheck>,
 libgtest-dev <!nocheck>,
 libsqlite3-dev,
 libssl-dev,
 libtinyxml2-dev,
 nlohmann-json3-dev,
 python3 <!nocheck>,
 tao-pegtl-dev,
Standards-Version: 4.7.0
Homepage: https://github.com/eProsima/Fast-DDS
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/robotics-team/fastdds.git
Vcs-Browser: https://salsa.debian.org/robotics-team/fastdds
Description: C++ library for the Real Time Publish Subscribe Protocol
 This package is part of eProsima FastDDS.  RTPS is the wire interoperability
 protocol defined for the Data Distribution Service (DDS) standard by the
 Object Management Group (OMG).
 .
 The library is a standalone C++ implementation compliant with the OMG DDS 1.4
 and OMG RTPS 2.2 standards. It is a tier one implementation for ROS 2.
 Compared to other free DDS implementations, it is very feature-complete and
 provides two API layers: one for high-level Publish-Subscriber access that
 focuses on usability, and a lower-level Writer-Reader API that allows more
 sophisticated fine tuning of the RTPS protocol.

Package: libfastdds3.1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package installs the shared library.

Package: fastdds-tools
Section: net
Architecture: any
Depends:
 python3:any,
 ${misc:Depends},
 ${shlibs:Depends},
Description: eProsima FastDDS Discovery Server and Tools
 This package is part of eProsima FastDDS. It is a tier one implementation
 for ROS 2.
 .
 This package provides the Fast Discovery Server to facilitate reliable
 discovery of participants in the FastDDS network, and the FastDDS
 introspection tool.

Package: libfastdds-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libasio-dev,
 libfastcdr-dev,
 libfastdds3.1 (= ${binary:Version}),
 libfoonathan-memory-dev,
 libssl-dev,
 libtinyxml2-dev,
 ${misc:Depends},
Breaks:
 libfastrtps-dev (<< 3),
Replaces:
 libfastrtps-dev (<< 3),
Provides:
 libfastrtps-dev,
Suggests:
 fastddsgen,
 libfastdds-doc,
Description: ${source:Synopsis} - development headers
 ${source:Extended-Description}
 .
 This package installs the development headers.

Package: libfastdds-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends},
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package installs the documentation.

Package: libfastrtps-dev
Section: oldlibs
Architecture: all
Depends:
 libfastdds-dev,
 ${misc:Depends},
Description: ${source:Synopsis} - transitional dummy package
 This is a transitional dummy package which can be safely removed.
